// loads and prepares the clock
function loadBinaryClock() {
	updateTime();
}

// updates the clock time
function updateTime() {
	// document.getElementById('clockDisplay').innerHTML = prepareTime( new Date(), "" );
	prepareTime( new Date(), "" );
	setTimeout("updateTime()", 100);
}

// this prepares the time into a string, it takes a time and turns it into a binary string seperated by 'spacing'
function prepareTime( now, spacing ) {
	lightCells(padString(toBinary(now.getSeconds()), 6), "second_");
	lightCells(padString(toBinary(now.getMinutes()), 6), "minute_");
	lightCells(padString(toBinary(now.getHours()), 6), "hour_");
	//return padString(toBinary(now.getHours()), 5) + spacing + padString(toBinary(now.getMinutes()), 6) + spacing + padString(toBinary(now.getSeconds()), 6);
}

function lightCells( binaryString, idPrefix ) {
	n = 6;
	while(n > 0) {
	    if(binaryString.charAt(6 - n) == '0') {
		    //it was a zero
			//document.getElementById(idPrefix + n).style.backgroundColor = "#174e0c";
			document.getElementById(idPrefix + n).style.opacity = 0.25;
			document.getElementById(idPrefix + n).style.filter = "alpha(opacity=25)";
			//document.getElementById(idPrefix + n).style.-moz-opacity = "0.5";
		} else {
			//it was a one
			//document.getElementById(idPrefix + n).style.backgroundColor = "#37d319";
			document.getElementById(idPrefix + n).style.opacity = 1;
			document.getElementById(idPrefix + n).style.filter = "alpha(opacity=100)";
			//document.getElementById(idPrefix + n).style.-moz-opacity = "1.0";
		}
		n--;
	}
}

/*
// this is the default preperation of time with no spacing character
function prepareTime( now ) {
	return prepareTime(now, "");
}
*/

// converts an integer to a binary string
function toBinary( n ) {
	n = parseInt(n);

	if(n == 0) return "0";

	if(n % 2 == 0) return toBinary( n / 2 ) + "0";
	else return toBinary( n / 2 ) + "1";
}

// pads a string with '0' to 'len' length
function padString( str, len ) {
	if(str.length > len) return str.substring(str.length-len, str.length);

	while(str.length < len) {
		str = "0" + str;
	}
	return str;
}

// convert string to images
function convertToImages( str ) {
	var rtnStr = "";
	for(var i = 0; i < str.length; i++) {
		if(str.charAt(i) == '0') rtnStr = rtnStr + "<img src=\"zero.png\">";
		else rtnStr = rtnStr + "<img src=\"one.png\">";
	}
	return rtnStr;
}